#include <stdio.h>
#include<stdlib.h>
#include<math.h>
#include"SimpleImage.h"
#include"pgmio.h"
#include"ppmio.h"
#include"otsu.h"
#include"label.h"





int main(int argc, char* argv[])
{
  Image *in = new Image();

  getPGM(in,argv[1]);
  
  Image *out = new Image(in->sx,in->sy);
  
  /* main processing */
  int i,j;

  int HISTSIZE=256;
  Otsu *myotsu = new Otsu(HISTSIZE);

  double threshold = ((double)(myotsu->find_otsu_threshold(in)));
  printf("Otsu's threshold value = %lf\n",threshold);
  delete myotsu;
  
  for(i=0;i<in->sy;i++)
    for(j=0;j<in->sx;j++){
      if(in->img[i][j]>=threshold){
	out->img[i][j] = 255.0;
      }else{
	out->img[i][j] = 0.0;
      }
    }
  
  Labeling *mylabel = new Labeling();
  int labeledN = mylabel->doLabeling(out);
  out->gray = labeledN;
  printf("Number of connected objects = %d\n",labeledN);
  //End Labeling
  delete mylabel;

  /* end main processing */

  
  savePGM(out,argv[2]);

  delete out;
  delete in;
  
  return 0;
}
