#include <stdio.h>
#include<stdlib.h>
#include<math.h>
#include"SimpleImage.h"
#include"pgmio.h"
#include"ppmio.h"
#include"color.h"
#include"otsu.h"
#include"label.h"


double getVal0to255(double val){
  int vali =((int)(((double)(255.0*val))));
  if(fabs((double)(val-vali))>=0.5)vali++;
  if(vali<0)vali=0;
  if(vali>255)vali=255;
  return ((double)(vali));
}


int main(int argc, char* argv[])
{
  Image *in = new Image();

  getPGM(in,argv[1]);
  
  Image *out = new Image(in->sx,in->sy);
  
  /* main processing */
  int i,j;

  int HISTSIZE=256;
  Otsu *myotsu = new Otsu(HISTSIZE);

  double threshold = ((double)(myotsu->find_otsu_threshold(in)));
  printf("Otsu's threshold value = %lf\n",threshold);
  delete myotsu;

  for(i=0;i<in->sy;i++)
    for(j=0;j<in->sx;j++){
      if(in->img[i][j]>=threshold){
	out->img[i][j] = 255.0;
      }else{
	out->img[i][j] = 0.0;
      }
    }
  
  //Labeling
  Labeling *mylabel = new Labeling();
  int labeledN = mylabel->doLabeling(out);
  out->gray = labeledN;
  printf("Number of connected objects = %d\n",labeledN);
  //End Labeling
  delete mylabel;

  //for Coloring
  double maxval=out->img[0][0];
  for(i=0;i<out->sy;i++)
    for(j=0;j<out->sx;j++){
      if(maxval<out->img[i][j]){
	maxval = out->img[i][j];
      }
    }
  if(maxval<=0.0)maxval=1.0;
  
  Image *outR = new Image(in->sx,in->sy);
  Image *outG = new Image(in->sx,in->sy);
  Image *outB = new Image(in->sx,in->sy);
  
  for(i=0;i<in->sy;i++)
    for(j=0;j<in->sx;j++){
      double val = biR((out->img[i][j]/maxval));
      outR->img[i][j] = getVal0to255(val);
      val = biG((out->img[i][j]/maxval));
      outG->img[i][j] = getVal0to255(val);
      val = biB((out->img[i][j]/maxval));
      outB->img[i][j] = getVal0to255(val);
      
      
    }
  

  

  /* end main processing */

  
  savePPM(outR,outG,outB,argv[2]);


  delete outR;
  delete outG;
  delete outB;
  delete out;
  delete in;
  
  return 0;
}
