

class Otsu{
 public:
  int HIST_CLASS;
  int *myhist;
  
  
  
  Otsu(int val){
    HIST_CLASS = val;
    myhist = new int[HIST_CLASS];
  }
  
  virtual ~Otsu(){
    delete [] myhist;
  }
  
  
    
  int find_otsu_threshold(Image *in){
    histogram(in,HIST_CLASS,myhist);
    return find_hist_threshold(HIST_CLASS,myhist);
  }
  
  
      
 private:
  void histogram(Image *in, int hsize, int *hist){
    int i,x,y;
    for(i=0;i<hsize;i++)hist[i]=0;
    
    for(y=0;y<in->sy;y++)
      for(x=0;x<in->sx;x++){
	int val = ((int)(in->img[y][x]));
	if(val>HIST_CLASS-1)val=HIST_CLASS-1;
	if(val<0)val=0;
	
	hist[val]++;
      }
  }
    
      
  
  bool find_hist_range(int hsize, int *hist, int *class_min, int *class_max)
  {
    int i;
    
    for (i = 0; i < hsize; i++) {
      if (hist[i] != 0)
	break;
    }
    if (i >= hsize) {
      return false;  
    }
    *class_min = i;
    
    for (i=hsize-1; i>=(*class_min); i--) {
      if (hist[i] != 0)
	break;
    }
    *class_max = i;
    
    return true;
  }
  
  
  
  
  double getSmax(int thr,int hsize,int *hist){
    
    
  }
  
  int find_hist_threshold(int hsize, int *hist){
    int i;
    double Smax = getSmax(0,hsize,hist);
    int Tmax = 0;
    
    for(i=1;i<hsize-1;i++){
      double S = getSmax(i,hsize,hist);
      printf("%lf\n",S);
      if(S>Smax){
	Tmax=i;
	Smax=S;
      }
      
    }
    return Tmax;
  }

 

  Otsu(const Otsu& rhs);
  const Otsu &operator=(const Otsu& rhs);
 
 
};

#undef PUT
